//Խꥢ
#include <string.h>
#include <assert.h>
#include <list>
#include <string>
using namespace std;

#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qmenubar.h>
#include <qpopupmenu.h>

#include "pin_c.xpm"
#include "pin_n.xpm"
#include "pin_s.xpm"
#include "pin_nc.xpm"
#include "pin_norm.xpm"
#include "pin_nul.xpm"

#include "coord.h"
#include "ce3io.h"
#include "complib.h"
#include "compeditwnd.h"
#include "componentview.h"
#include "ptneditdialog.h"
#include "ptneditview.h"




enum LCO_PIN_TYPE
{
	LCO_PIN_TYPE_INIT	= -2,
	LCO_PIN_TYPE_NULL	= -1,
	LCO_PIN_TYPE_NORM	= PIN_TYPE_NOMAL,
	LCO_PIN_TYPE_C		= PIN_TYPE_CLOCK,
	LCO_PIN_TYPE_N		= PIN_TYPE_NEGATIVE,
	LCO_PIN_TYPE_NC		= PIN_TYPE_NEGATIVE|PIN_TYPE_CLOCK,
	LCO_PIN_TYPE_S		= PIN_TYPE_SMALL,
	LCO_PIN_TYPE_MASK	= PIN_TYPE_SMALL|PIN_TYPE_NEGATIVE|PIN_TYPE_CLOCK
};



SCompEditWnd::SCompEditWnd( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
	m_ltrb = -1;
	m_offset = -1;
	m_compIndex = NULL;
	m_modified = false;
	m_pintype = LCO_PIN_TYPE_INIT;


    QPixmap image_pin_n( ( const char** ) pin_n );
    QPixmap image_pin_s( ( const char** ) pin_s );
    QPixmap image_pin_nc( ( const char** ) pin_nc );
    QPixmap image_pin_c( ( const char** ) pin_c );
    QPixmap image_pin_nul( ( const char** ) pin_nul );
    QPixmap image_pin_norm( ( const char** ) pin_norm );


    if ( !name ) setName( "CompEditWnd" );
    Layout6 = new QGridLayout(this);
//    Layout6 = new QGridLayout;
    Layout6->setSpacing( 6 );
    Layout6->setMargin( 0 );

    Layout5 = new QGridLayout; 
    Layout5->setSpacing( 6 );
    Layout5->setMargin( 0 );


	//ԥ̾
    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setProperty( "text", tr( "Value" ) );
    TextLabel1->setProperty( "alignment", int( QLabel::AlignVCenter | QLabel::AlignRight ) );
    Layout6->addWidget( TextLabel1, 0, 0 );
    LineEditValue = new QLineEdit( this, "LineEditValue" );
    Layout6->addMultiCellWidget( LineEditValue, 0, 0, 1, 3 );

	//ԥֹ
    TextLabel1_2 = new QLabel( this, "TextLabel1_2" );
    TextLabel1_2->setProperty( "text", tr( "Num" ) );
    TextLabel1_2->setProperty( "alignment", int( QLabel::AlignVCenter | QLabel::AlignRight ) );
    Layout6->addWidget( TextLabel1_2, 1, 0 );
    LineEditNum = new QLineEdit( this, "LineEditNum" );
    Layout6->addWidget( LineEditNum, 1, 1 );

	//֥å
    TextLabel1_2_2 = new QLabel( this, "TextLabel1_2_2" );
    TextLabel1_2_2->setProperty( "text", tr( "Block" ) );
    TextLabel1_2_2->setProperty( "alignment", int( QLabel::AlignVCenter | QLabel::AlignRight ) );
    Layout6->addWidget( TextLabel1_2_2, 1, 2 );
    SpinBox1 = new QSpinBox( this, "SpinBox1" );
    SpinBox1->setProperty( "sizePolicy", QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, SpinBox1->sizePolicy().hasHeightForWidth() ) );
	SpinBox1->setMaxValue(1);
	SpinBox1->setMinValue(1);
	SpinBox1->setValue(1);
    Layout6->addWidget( SpinBox1, 1, 3 );

	//ԥֹɽåܥå
    CheckHidePin = new QCheckBox( this, "CheckHidePin" );
    CheckHidePin->setProperty( "text", tr( "Hide pin number" ) );
    Layout6->addMultiCellWidget( CheckHidePin, 2, 2, 0, 3 );

	//NULLԥ
    RadioNullPin = new QRadioButton( this, "RadioNullPin" );
    RadioNullPin->setProperty( "text", tr( "" ) );
    RadioNullPin->setProperty( "pixmap", image_pin_nul );
    Layout5->addWidget( RadioNullPin, 0, 0 );

	//̾ԥ
    RadioNormPin = new QRadioButton( this, "RadioNormPin" );
    RadioNormPin->setProperty( "text", tr( "" ) );
    RadioNormPin->setProperty( "pixmap", image_pin_norm );
    Layout5->addWidget( RadioNormPin, 1, 0 );

	//åԥ
    RadioCPin = new QRadioButton( this, "RadioCPin" );
    RadioCPin->setProperty( "text", tr( "" ) );
    RadioCPin->setProperty( "pixmap", image_pin_c );
    Layout5->addWidget( RadioCPin, 0, 1 );

	//ԥ
    RadioNPin = new QRadioButton( this, "RadioNPin" );
    RadioNPin->setProperty( "text", tr( "" ) );
    RadioNPin->setProperty( "pixmap", image_pin_n );
    Layout5->addWidget( RadioNPin, 1, 1 );


	//åԥ
    RadioNCPin = new QRadioButton( this, "RadioNCPin" );
    RadioNCPin->setProperty( "text", tr( "" ) );
    RadioNCPin->setProperty( "pixmap", image_pin_nc );
    Layout5->addWidget( RadioNCPin, 0, 2 );

	//Smallԥ
    RadioSPin = new QRadioButton( this, "RadioSPin" );
    RadioSPin->setProperty( "text", tr( "" ) );
    RadioSPin->setProperty( "pixmap", image_pin_s );
    Layout5->addWidget( RadioSPin, 1, 2 );
    
	Layout6->addMultiCellLayout( Layout5, 3, 3, 0, 4 );



    buttonOk = new QPushButton( this, "buttonOk" );
    buttonOk->setProperty( "sizePolicy", QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, buttonOk->sizePolicy().hasHeightForWidth() ) );
    buttonOk->setProperty( "caption", tr( "" ) );
    buttonOk->setProperty( "text", tr( "Update" ) );
    buttonOk->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    buttonOk->setProperty( "default", QVariant( TRUE, 0 ) );
    Layout6->addWidget( buttonOk, 0, 4 );


    buttonEditPattern = new QPushButton( this, "buttonEditPattern" );
    //buttonEditPattern->setProperty( "sizePolicy", QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, buttonEditPattern->sizePolicy().hasHeightForWidth() ) );
    buttonEditPattern->setProperty( "caption", tr( "" ) );
    buttonEditPattern->setProperty( "text", tr( "Pattern..." ) );
    buttonEditPattern->setProperty( "autoDefault", QVariant( TRUE, 0 ) );
    buttonEditPattern->setProperty( "default", QVariant( TRUE, 0 ) );
    Layout6->addWidget( buttonEditPattern, 1, 4 );



	ComponentView = new SComponentView(this,true);
	Layout6->addMultiCellWidget( ComponentView, 4,4,0,4);
	connect(ComponentView,SIGNAL( cursorMoved() ),this,SLOT( onCursorMoved() ));
	connect(SpinBox1,SIGNAL( valueChanged(int) ),this,SLOT( onSpinBlockChanged(int) ));

    connect(RadioNullPin		,SIGNAL( clicked() ),this,SLOT( onPinTypeNull()		));
    connect(RadioNormPin		,SIGNAL( clicked() ),this,SLOT( onPinTypeNorm()		));
    connect(RadioCPin			,SIGNAL( clicked() ),this,SLOT( onPinTypeC()		));
	connect(RadioNPin			,SIGNAL( clicked() ),this,SLOT( onPinTypeN()		));
    connect(RadioNCPin			,SIGNAL( clicked() ),this,SLOT( onPinTypeNC()		));
    connect(RadioSPin			,SIGNAL( clicked() ),this,SLOT( onPinTypeS()		));
	connect(buttonOk			,SIGNAL( clicked() ),this,SLOT( onButtonUpdatePin()	));
	connect(buttonEditPattern	,SIGNAL( clicked() ),this,SLOT( onButtonPattern()	));

	setEnableControls();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
SCompEditWnd::~SCompEditWnd()
{
    // no need to delete child widgets, Qt does it all for us
}

void SCompEditWnd::setCompIndex(SCompIndex* compIndex)
{
	ComponentView->setComponentIndex(compIndex);
	m_ltrb = -1;
	m_offset = -1;
	m_block = 0;
	m_modified = false;
	m_pintype = LCO_PIN_TYPE_INIT;
	m_compIndex = compIndex;
	if(compIndex != NULL){
		m_blockcount = compIndex->block();
	}else{
		m_blockcount = 1;
	}
	SpinBox1->setMaxValue(m_blockcount);
	SpinBox1->setValue(1);
	setControls();
	setEnableControls();
}

void SCompEditWnd::setControls()
{
	QString value="";
	QString number="";
	bool hideNumber=false;

	if(m_compIndex==NULL){
		m_pintype = LCO_PIN_TYPE_INIT;
	}else{
		SCompInfo* pCompInfo = m_compIndex->compInfo();
		SPin* ppin = pCompInfo->pinInfo(m_ltrb,m_offset);
		if(ppin==NULL){
			m_pintype = LCO_PIN_TYPE_NULL;
		}else{
			m_pintype = ppin->type() & LCO_PIN_TYPE_MASK;
			string name = pinNameToString(ppin->pinName());
			value = QString::fromLatin1(name.c_str());
			number = QString::fromLatin1(ppin->pinNum(m_block));
			hideNumber = ppin->type() & PIN_TYPE_NUMHIDE;
		}
	}
	setPinTypeRadioButton();
	LineEditValue->setText(value);
	LineEditNum->setText(number);
	CheckHidePin->setChecked(hideNumber);
}


void SCompEditWnd::onCursorMoved()
{
	if(m_compIndex==NULL) return;
	int ltrb = ComponentView->cursorLTRB();
	int offset = ComponentView->cursorOffset();
	//qDebug("SCompEditWnd::onCursorMove() %d %d",ltrb,offset);
	m_ltrb = ltrb;
	m_offset = offset;


	setControls();
	setEnableControls();
}

void SCompEditWnd::onSpinBlockChanged(int value)
{
	//qDebug("SCompEditWnd::onSpinBlockChanged() %d",value);
	m_block = value-1;
	ComponentView->setBlock(m_block);
	setControls();
	setEnableControls();
}

void SCompEditWnd::setEnableControls()
{
	bool enable = (m_ltrb != -1 && m_offset != -1);
    RadioNPin->setEnabled(m_block==0 && enable);
    RadioSPin->setEnabled(m_block==0 && enable);
    RadioNCPin->setEnabled(m_block==0 && enable);
    RadioCPin->setEnabled(m_block==0 && enable);
    RadioNullPin->setEnabled(m_block==0 && enable);
    RadioNormPin->setEnabled(m_block==0 && enable);
    CheckHidePin->setEnabled(m_block==0 && enable && m_pintype>=0);
    LineEditValue->setEnabled(m_block==0 && enable && m_pintype>=0);
    LineEditNum->setEnabled(enable && m_pintype>=0);
	buttonOk->setEnabled(enable);
	bool hasPattern;
	if(m_compIndex==NULL){
		hasPattern = false;
	}else{
		hasPattern=(m_compIndex->pattern()!=NULL);
	}
	buttonEditPattern->setEnabled(m_block==0 && hasPattern);
}

string SCompEditWnd::pinNameToString(const string& pinName)
{
	string str;
	int length = pinName.length();
	int i;
	for(i=0;i<length;i++){
		char cc = pinName[i];
		if(cc & 0x80){
			str+='\\';
			str+=cc&0x7F;
		}else{
			str+=cc;
		}
	}
	return str;
}

string SCompEditWnd::stringToPinName(const string& str)
{
	string pinName;
	int length = str.length();
	int i;
	bool upperLineFlag=false;
	for(i=0;i<length;i++){
		char cc = str[i];
		if(cc == '\\'){
			upperLineFlag=true;
		}else{
			if(upperLineFlag){
				cc |= 0x80;
				upperLineFlag=false;
			}
			pinName += cc;
		}
	}
	return pinName;
}



void SCompEditWnd::setPinTypeRadioButton()
{	
    RadioNPin->setChecked (m_pintype == LCO_PIN_TYPE_N);
    RadioSPin->setChecked (m_pintype == LCO_PIN_TYPE_S);
    RadioNCPin->setChecked (m_pintype == LCO_PIN_TYPE_NC);
    RadioCPin->setChecked (m_pintype == LCO_PIN_TYPE_C);
    RadioNullPin->setChecked (m_pintype == LCO_PIN_TYPE_NULL);
    RadioNormPin->setChecked (m_pintype == LCO_PIN_TYPE_NORM);
}

void SCompEditWnd::onPinTypeNull()
{
	m_pintype = LCO_PIN_TYPE_NULL;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onPinTypeNorm()
{
	m_pintype = LCO_PIN_TYPE_NORM;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onPinTypeC()
{
	m_pintype = LCO_PIN_TYPE_C;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onPinTypeN()
{
	m_pintype = LCO_PIN_TYPE_N;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onPinTypeNC()
{
	m_pintype = LCO_PIN_TYPE_NC;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onPinTypeS()
{
	m_pintype = LCO_PIN_TYPE_S;
	setPinTypeRadioButton();
	setEnableControls();
}

void SCompEditWnd::onButtonUpdatePin()
{
	//qDebug("SCompEditWnd::onButtonUpdatePin");
	if(m_compIndex==NULL) return;
	if(m_ltrb<0 || m_offset<0)return;
	QString qsnewvalue=LineEditValue->text();
	string newvalue = pinNameToString(qsnewvalue.latin1());
	QString qsnewnumber=LineEditNum->text();
	string newnumber = qsnewnumber.latin1();
	bool newHideNumber=CheckHidePin->isChecked();
	int newPinType = m_pintype;
	if(newHideNumber) newPinType |= PIN_TYPE_NUMHIDE;
	
	int oldPinType=-1;
	
	SCompInfo* pCompInfo = m_compIndex->compInfo();
	SPin* ppin = pCompInfo->pinInfo(m_ltrb,m_offset);
	if(ppin==NULL && m_pintype<0) return;	//NULLԥ󤫤ѹʤ
	bool pinmodified = false;
	if(m_pintype<0){
		pCompInfo->removePin(m_ltrb,m_offset,false);
		pinmodified = true;
	}else if(ppin==NULL){
		//qDebug("SCompEditWnd::onButtonUpdatePin()  Create new pin.");
		ppin=new SPin;
		ppin->setLtrb(m_ltrb);
		ppin->setOffset(m_offset);
		ppin->setBlock(m_blockcount);
		ppin->setType(newPinType);
		ppin->setPinName(newvalue.c_str());
		ppin->setPinNum(m_block,newnumber.c_str());
		pCompInfo->addPin(ppin);
		pinmodified = true;
	}else{
		if(ppin->type() !=  newPinType){
			ppin->setType(newPinType);
			pinmodified = true;
		}
		if(ppin->pinName() != newvalue){
			ppin->setPinName(newvalue.c_str());
			pinmodified = true;
		}
		if(ppin->pinNum(m_block) != newnumber){
			ppin->setPinNum(m_block,newnumber.c_str());
			pinmodified = true;
		}
	}
	if(pinmodified){
		m_modified = true;
		emit modifiedSignal();
		ComponentView->RefreshView();
	}
}

void SCompEditWnd::onButtonPattern()
{
	if(m_compIndex==NULL) return;
	SCompInfo* pCompInfo = m_compIndex->compInfo();
	SPtn* pPtn = pCompInfo->m_pPtn;
	if(pPtn==NULL) return;


	ptneditDialog *dlg = new ptneditDialog(this,0,true);
	//dlg->setModal(true);
	dlg->setMinimumWidth(400);
	dlg->m_pPtnEditView->setPtn(*pPtn);
	dlg->exec();
	delete pPtn;
	pPtn = new SPtn(dlg->m_pPtnEditView->ptn());
	pCompInfo->m_pPtn = pPtn;
	ComponentView->RefreshView();
	m_modified = true;
	emit modifiedSignal();
}

void SCompEditWnd::pinInsert()
{
	if(m_compIndex==NULL) return;
	if(m_ltrb<0 || m_offset<0)return;
	SCompInfo* pCompInfo = m_compIndex->compInfo();
	pCompInfo->insertNullPin(m_ltrb,m_offset);
	setControls();
	setEnableControls();
	ComponentView->RefreshView();
	m_modified = true;
	emit modifiedSignal();
}

void SCompEditWnd::pinDelete()
{
	if(m_compIndex==NULL) return;
	if(m_ltrb<0 || m_offset<0)return;
	SCompInfo* pCompInfo = m_compIndex->compInfo();
	pCompInfo->removePin(m_ltrb,m_offset,true);
	setControls();
	setEnableControls();
	ComponentView->RefreshView();
	m_modified = true;
	emit modifiedSignal();
}

