#ifndef COMPEDITWND_H
#define COMPEDITWND_H

#include <qvariant.h>
#include <qwidget.h>
#include <string>
using namespace std;
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QLabel;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QPushButton;
class QRadioButton;
class QSpinBox;
class QToolButton;
class QMenuBar;

class SComponentView;
class SCompIndex;



class SCompEditWnd : public QWidget
{ 
    Q_OBJECT

public:
    SCompEditWnd( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~SCompEditWnd();
	void setCompIndex(SCompIndex* compIndex);
	bool modified(){return m_modified;}
	void pinInsert();
	void pinDelete();

protected:
	void setControls();
	void setEnableControls();
	void setPinTypeRadioButton();
	string pinNameToString(const string& pinName);
	string stringToPinName(const string& str);

signals:
	void modifiedSignal();

protected:
    QRadioButton* RadioNPin;
    QRadioButton* RadioSPin;
    QRadioButton* RadioNCPin;
    QRadioButton* RadioCPin;
    QRadioButton* RadioNullPin;
    QRadioButton* RadioNormPin;
    QCheckBox* CheckHidePin;
    QLabel* TextLabel1_2_2;
    QLineEdit* LineEditNum;
    QLineEdit* LineEditValue;
    //QPushButton* buttonCancel;
    QLabel* TextLabel1_2;
    QPushButton* buttonOk;
    QPushButton* buttonEditPattern;
    QSpinBox* SpinBox1;
    QLabel* TextLabel1;
	SComponentView* ComponentView;

    QGridLayout* Layout6;
    QGridLayout* Layout5;

protected:
	int  m_ltrb;
	int  m_offset;
	int  m_block;
	int	 m_blockcount;	//m_block  0m_blockcount-1
	int  m_pintype;
	SCompIndex* m_compIndex;
	bool m_modified;

protected slots:
	void onCursorMoved();
	void onSpinBlockChanged(int);
	void onPinTypeNull();
	void onPinTypeNorm();
	void onPinTypeC();
	void onPinTypeN();
	void onPinTypeNC();
	void onPinTypeS();
	void onButtonUpdatePin();
	void onButtonPattern();
};
#endif
