#include "inputaliasimpl.h"

#include <qlineedit.h>
#include <qlabel.h>
/* 
 *  Constructs a inputalias which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
inputalias::inputalias( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : inputaliasBase( parent, name, modal, fl )
{
}

/*  
 *  Destroys the object and frees any allocated resources
 */
inputalias::~inputalias()
{
    // no need to delete child widgets, Qt does it all for us
}

int inputalias::exec()
{
	TextLabelName->setText(m_name);
	LineEditAlias->setText(m_name);
	LineEditAlias->setFocus();
	return inputaliasBase::exec();
}

void inputalias::accept()
{
	m_alias = LineEditAlias->text();
	inputaliasBase::accept();
}
