#ifndef LCODIALOG_H
#define LCODIALOG_H

#include <qvariant.h>
#include <qmainwindow.h>
#include <qlistbox.h>
#include <qwidgetlist.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QLabel;
class QLineEdit;
//class QListBox;
class QPushButton;
class QRadioButton;
class QSpinBox;
class QToolButton;
class QMenuBar;

class SCompEditWnd;
class SCompLib;
class SCompIndex;

class SLCoListItem : public QListBoxItem
{
public:
	SLCoListItem(){
		m_pCompIndex=NULL;
		m_bAlias = false;
	}
	~SLCoListItem(){
	//	qDebug("delete SLCoListItem");
	}

public:
	bool m_bAlias;
	SCompIndex* m_pCompIndex;
	//void setItemText( const QString& test);
protected:
	void paint (QPainter * p);
	int height ( const QListBox * ) const;
	int width ( const QListBox * ) const;
};

class lcoDialog : public QWidget
{ 
    Q_OBJECT

public:
//    lcoDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    lcoDialog( QWidget* parent = 0, const char* name = 0);
	~lcoDialog();
	QString fileName();
	bool writeLibrary(const QString& filename);
	bool readLibrary(const QString& filename);
	bool isEmptyDocWindow();
	static  lcoDialog* firstEmptyDocWindow();

protected:
	QMenuBar* menuBar;
    QToolButton* button_up;
    QToolButton* button_down;
    QListBox* ListBox1;
	SCompEditWnd* CompEdit;
	QPopupMenu *m_menuWindow;


protected:

    QGridLayout* lcoDialogLayout;
    QVBoxLayout* Layout3;
    QHBoxLayout* Layout2;

protected:
	SCompLib*	m_compLib;
	bool		m_bDirty;
	QString		m_strDocumentPath;



	void setListBox();

	void setDialogCaption();
	void initDocument();
	bool saveIfDirty();
	static QWidgetList m_appWindowList;

protected slots:
	//void accept();
	//void reject();
	//bool close();
	void closeEvent( QCloseEvent* ce );

	//MENU
	//FILE
	bool fileNew();
	void fileOpen();
	bool fileSave();
	bool fileSaveAs();
	void fileExit();
	//Component
	void componentCut();
	void componentCopy();
	void componentPaste();
	void componentDel();
	void componentNew();
	void componentAttribute();
	void componentAlias();
	//Pin
	void pinInsert();
	void pinDelete();
	//Help
	void helpAbout();
	//Controls
	void listboxSelectionChanged();
	//Up/Down
	void onButtonUp();
	void onButtonDown();

	void onCompEditModified();
	
	//Windowj[XṼ^C~O󂯎
	void setupWindowMenu();
	
	//Windowj[̃ACeIꂽƂSLOT
	void selectActiveDocument(int id);

};
#endif
