#include <qapplication.h>
#include <qmessagebox.h>
#include <string.h>
#include <Carbon/Carbon.h>
#include "lcodialog.h"


OSStatus openDocumentsHandler(const AppleEvent* appleEvt,AppleEvent* reply,SInt32 refcon)
{
	//printf("openDocumentsHandler\n");

	AEDesc fileList ={typeNull,NULL};
	OSErr err;
	SInt32 itemsInList;

	
	err = AEGetParamDesc(appleEvt,keyDirectObject, typeAEList,&fileList);
	if(err == noErr){
		err = AECountItems(&fileList,&itemsInList);
		if(err == noErr && itemsInList >0){
			OSType keyword;
			OSType returnedType;
			Size actualSize;
			FSRef fileToOpen;
			char qstr_buf[1024];
			QString strFilename;
			int i;
			for(i=1;err==noErr && i<=itemsInList;i++){
				err = AESizeOfNthItem(&fileList, i, &returnedType, &actualSize);
				if(err == noErr){
					err = AEGetNthPtr(&fileList,i,typeFSRef,&keyword,
							&returnedType,&fileToOpen,
							sizeof(FSRef),&actualSize);
					if (err == noErr) {
						FSRefMakePath(&fileToOpen, (UInt8*)qstr_buf, 1024);
						strFilename=QString::fromUtf8(qstr_buf);
						lcoDialog * mw =lcoDialog::firstEmptyDocWindow();
						if(mw == NULL) mw = new lcoDialog(0,0);
						mw->show();
						mw->readLibrary(strFilename);
						mw->setActiveWindow();
					}
				}
			}
		}
		AEDisposeDesc(&fileList);
	}
	return err;
}


int main( int argc, char** argv )
{
	int n;
	QApplication app( argc, argv );
	
	AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments,
                        NewAEEventHandlerUPP((AEEventHandlerProcPtr)openDocumentsHandler),NULL,false);
	//2003/07/16 ɥݥ󥿤ѹ
	lcoDialog* pLCoWnd=new lcoDialog( 0, 0);
	//app.setMainWidget(pLCoWnd);
	
	pLCoWnd->show();

	app.connect( &app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()) );

	n=app.exec();

	//qDebug("main() end\n");

	return n;

//	return 0;
}

