// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <qcolor.h>
#include <qclipboard.h>
//#include <qtimer.h>
#include <string>
#include <list>
using namespace std;
#include <qapplication.h>
#include <qbitmap.h>
#include <qcursor.h>
#include <qmessagebox.h>
#include <qfont.h>
#include <qpainter.h>
#include "coord.h"

#include "complib.h"
#include "ptneditview.h"
#include "ce3io.h"


#define VIEW_MARGIN 20
#define ZOOMIN_SCALE 5
#define ZOOMOUT_SCALE 1


//󥹥ȥ饯
SPtnEditView::SPtnEditView(QWidget* parent):QScrollView (parent)
{
	viewport()->setBackgroundColor(QColor("white"));
	viewport()->setMouseTracking(true);
	//˥Сɽ
	setHScrollBarMode(AlwaysOn);
	setVScrollBarMode(AlwaysOn);

	m_buff			= NULL;
	m_buffTemp		= NULL;
	m_size.setWidth(51);
	m_size.setHeight(51);
	setupBuffer();


	m_viewScale =ZOOMIN_SCALE;		//Ψ
	m_toolmode  =TOOL_SELECTOR;		//ߤġΥ⡼

	m_bLButtonDown = false;			//ܥβ
	m_bRButtonDown = false;			//ܥβ
	m_bDrawSelectFrame =false;		//Ȥե饰
	m_bDrawTempLine =false;			//ľ߲ե饰
	m_bTempBuffer =false;			//m_buffTempͭʤȤtrue
	m_bDragTemp =false;				//ǡΰư


	QSize size = getContentsSize();
	resizeContents(size.width(),size.height());

}

//void SPtnEditView::setCopyBuff(SPtnEditCopyBuff* copyBuffer)
//{
//	m_pCopyBuffer = copyBuffer;
//}



//ǥȥ饯
SPtnEditView::~SPtnEditView()
{
	delete[]m_buff;
	delete[]m_buffTemp;
	//delete[]m_buffCopy;
}

bool SPtnEditView::setupBuffer()
{
	delete[]m_buff;
	delete[]m_buffTemp;
	//delete[]m_buffCopy;
	int i;
	int buffsize= m_size.width() * m_size.height();
	m_buff		= (unsigned char*)new char[buffsize];
	for(i=0;i<buffsize; i++) m_buff[i]=0;
	m_buffTemp	= (unsigned char*)new char[buffsize];
	for(i=0;i<buffsize; i++) m_buffTemp[i]=0;
	//m_buffCopy	= (unsigned char*)new char[buffsize];
	return true;
}

//ǡ򥼥ꥢ
void SPtnEditView::clearTemp()
{
	int i;
	int clearsize = m_tempSize.width() * m_tempSize.height();
	for(i=0;i<clearsize; i++) m_buffTemp[i]=0;
}


//ߤγΨȥѥΥ饹ӥ塼ΥƥĤΥ
QSize SPtnEditView::getContentsSize()
{
	int w = m_size.width() * m_viewScale + VIEW_MARGIN*2;
	int h = m_size.height() * m_viewScale + VIEW_MARGIN*2;
	return QSize(w,h);
}

bool SPtnEditView::CanZoomIn()
{
	return (m_viewScale==ZOOMOUT_SCALE);
}

bool SPtnEditView::CanZoomOut()
{
	return (m_viewScale==ZOOMIN_SCALE);
}

void SPtnEditView::ZoomIn()
{
	m_viewScale=ZOOMIN_SCALE;
	QSize size = getContentsSize();
	resizeContents(size.width(),size.height());
	RefreshView();
}


void SPtnEditView::ZoomOut()
{
	m_viewScale=ZOOMOUT_SCALE;
	QSize size = getContentsSize();
	resizeContents(size.width(),size.height());
	RefreshView();
}

//ԡ
void SPtnEditView::copy()
{
	if(m_toolmode != TOOL_SELECTOR) return;
	if(!m_bTempBuffer) return;

	toSPtn(m_tempSize.width(),m_tempSize.height(),m_buffTemp);

	string str;
	SWriteCE3 wce3;
	wce3.Attach(&str);

	wce3.WriteRecord("+LCO3_PTN_V.1.0");
	wce3.WriteEOL();
	m_SPtn.writeCe3(wce3,"Clipboard");
	wce3.WriteRecord("-LCO3_PTN_V.1.0");
	wce3.WriteEOL();
    QClipboard *cb = QApplication::clipboard();
    cb->setText(QString::fromLocal8Bit(str.c_str()));
}

//å
void SPtnEditView::cut()
{
	if(m_toolmode != TOOL_SELECTOR) return;
	copy();
	del();
}

bool SPtnEditView::canPaste()
{
	QString strID("+LCO3_PTN_V.1.0");
	QClipboard *cb = QApplication::clipboard();
    QString str = cb->text().left(strID.length());	
	return (str == strID);
}


//ڡ
void SPtnEditView::paste()
{
	if(m_toolmode != TOOL_SELECTOR) return;
	//if(m_pCopyBuffer == NULL) return;
	if(!canPaste()) return;

	if(m_bTempBuffer){
		QPainter *ppainter;
		ppainter = new QPainter(viewport());
		ppainter->translate ( -contentsX(),-contentsY() );
		drawTempData(ppainter,NULL,DRAW_XOR);
		drawTempFrame(ppainter);
		drawTempData(ppainter,NULL,DRAW_ON);
		delete ppainter;
		resetSelect(true);
	}

	QPoint ptOffset(contentsX(),contentsY());
	ptOffset=ContentsToPtn(ptOffset);
	if(ptOffset.x()<0) ptOffset.setX(0);
	if(ptOffset.y()<0) ptOffset.setY(0);
	if(ptOffset.x()>=m_size.width()) ptOffset.setX(m_size.width()-1);
	if(ptOffset.y()>=m_size.height()) ptOffset.setY(m_size.height()-1);

	int w = m_size.width();
	int h = m_size.height();

    QClipboard *cb = QApplication::clipboard();
	string cbbuff=string(cb->text().local8Bit());

	SReadCE3 rce3;
	rce3.Attach(cbbuff.c_str());

	string str;


	rce3.ReadRecord(str);
	if(str != "+LCO3_PTN_V.1.0") return;
	rce3.ReadRecord(str);
	if(str != "+PTN") return;
	if(m_SPtn.readCe3(rce3)){
		fromSPtn(m_SPtn,w,h,w,h,m_buffTemp);
		m_tempSize.setWidth(w);
		m_tempSize.setHeight(h);
		m_bTempBuffer=true;
		m_tempOffset=ptOffset;
		QPainter *ppainter;
		ppainter = new QPainter(viewport());
		ppainter->translate ( -contentsX(),-contentsY() );

		drawTempFrame(ppainter);
		drawTempData(ppainter,NULL,DRAW_XOR);
		delete ppainter;
	}
}

//
void SPtnEditView::del()
{
	if(m_toolmode != TOOL_SELECTOR) return;

	if(m_bTempBuffer){
		QPainter *ppainter;
		ppainter = new QPainter(viewport());
		ppainter->translate ( -contentsX(),-contentsY() );
		drawTempFrame(ppainter);
		drawTempData(ppainter,NULL,DRAW_OFF);
		delete ppainter;
	}
	m_bTempBuffer=false;
//	RefreshView();
}

//Rotate
void SPtnEditView::rotate()
{
	if(m_toolmode != TOOL_SELECTOR) return;
	if(!m_bTempBuffer) return;

	QPainter *ppainter;
	ppainter = new QPainter(viewport());
	ppainter->translate ( -contentsX(),-contentsY() );

	drawTempFrame(ppainter);
	drawTempData(ppainter,NULL,DRAW_XOR);

	int w=m_tempSize.width();
	int h=m_tempSize.height();
	unsigned char* buff=(unsigned char*) new char[w*h];
	unsigned char* ps = m_buffTemp;
	unsigned char* pd;
	int i,j;
	for(i=0;i<h;i++){
		pd = buff+(h-i-1);
		for(j=0;j<w;j++){
			*pd = *ps++;
			pd+=h;
		}
	}

	int len = w*h;
	ps = buff;
	pd = m_buffTemp;
	for(i=0;i<len;i++){
		*pd++ = *ps++;
	}
	m_tempSize.setWidth(h);
	m_tempSize.setHeight(w);
	delete[]buff;

	drawTempData(ppainter,NULL,DRAW_XOR);
	drawTempFrame(ppainter);
	delete ppainter;

}


//Mirror
void SPtnEditView::mirror()
{
	if(m_toolmode != TOOL_SELECTOR) return;
	if(!m_bTempBuffer) return;

	QPainter *ppainter;
	ppainter = new QPainter(viewport());
	ppainter->translate ( -contentsX(),-contentsY() );

	drawTempData(ppainter,NULL,DRAW_XOR);

	int w=m_tempSize.width();
	int h=m_tempSize.height();
	unsigned char* pl;
	unsigned char* pr;
	unsigned char cc;
	int i,j;
	for(i=0;i<h;i++){
		pl = m_buffTemp+w*i;
		pr = pl+w-1;
		for(j=0;j<w/2;j++){
			cc=*pl;
			*pl=*pr;
			*pr=cc;
			pl++;
			pr--;
		}
	}

	drawTempData(ppainter,NULL,DRAW_XOR);
	delete ppainter;

}

void SPtnEditView::resetSelect(bool bSet)
{
	if(!m_bTempBuffer) return;
	int w=m_size.width();
	int h=m_size.height();
	int tw=m_tempSize.width();
	int th=m_tempSize.height();
	int x=m_tempOffset.x();
	int y=m_tempOffset.y();
	int i,j;
	for(i=0;i<th && y<h;i++){
		if(y>=0){
			int xc=x;
			unsigned char* pd = m_buff+y*w+x;
			unsigned char* ps = m_buffTemp+i*tw;
			for(j=0;j<tw && xc<w;j++){
				if(xc>=0){
					if(bSet){
						*pd |= *ps;
					}else{
						if(*ps!=0) *pd =0;
					}
				}
				pd++;
				ps++;
				xc++;
			}
		}
		y++;
	}
	m_bTempBuffer=false;
}


bool SPtnEditView::select(const QRect& rrc)
{
	resetSelect(true);
	QRect rc=rrc.normalize();
	int ls = rc.left();
	int ts = rc.top();
	int rs = rc.right();
	int bs = rc.bottom();

	bool retVal=false;
	int l=m_size.width();
	int t=m_size.height();
	int r=0;
	int b=0;

	int x,y;
	//ȤȤˡºݤONɥåȤ¸ߤϰϤ
	for(y=ts;y<=bs;y++){
		for(x=ls;x<=rs;x++){
			if(pixel(x,y)){
				retVal = true;
				if(x<l) l=x;
				if(x>r) r=x;
				if(y<t) t=y;
				if(y>b) b=y;
			}
		}
	}

	unsigned char* pd = m_buffTemp;
	unsigned char* ps;

	if(retVal){
		for(y=t;y<=b;y++){
			ps=m_buff+m_size.width()*y+l;
			for(x=l;x<=r;x++){
				*pd++ = *ps;
				*ps=0;
				ps++;
			}
		}
	}

	m_tempSize.setWidth(r-l+1);
	m_tempSize.setHeight(b-t+1);
	m_tempOffset =  QPoint(l,t);
	m_bTempBuffer=retVal;
	return retVal;
}

//ġ˴Ϣ᥽å
bool SPtnEditView::setToolMode(int toolMode)
{
	resetSelect(true);
	viewport()->update();
	if(m_toolmode == toolMode) return false;
	m_toolmode = toolMode;
	//ľȱߤΥ⡼ɤǤϡǡΥХåեѥΥƱˤ롣
	if(m_toolmode == TOOL_LINE || m_toolmode == TOOL_CIRCLE){
		m_tempSize = m_size;
		m_tempOffset = QPoint(0,0);
	}
	return true;
}


//ꤷSPtnХåե
//SPtnΥdw,dhĶڤΤƤ
void SPtnEditView::fromSPtn(const SPtn& ptn,int& dw,int& dh,int maxw,int maxh,unsigned char* buff)
{
	int w = ptn.m_size.w();
	int h = ptn.m_size.h();
	int xbyte = (w+15)/16*2;
	int i,j;
	unsigned char* pd;
	unsigned char* ps;
	unsigned char bitmask;

	dw=w;
	dh=h;
	if(dw>maxw) dw=maxw;
	if(dh>maxh) dh=maxh;
	
	//j=dw*dh;
	//for(i=0;i<j;i++) buff[i]=0;
	
	
	for(i=0;i<dh;i++){
		ps=ptn.m_pBuff + i*xbyte;
		pd=buff + i*dw;
		bitmask = 0x80;
		for(j=0;j<dw;j++){
			if(*ps & bitmask)	*pd = 0xff;
			else				*pd = 0;
			pd++;
			if(bitmask==1){
				bitmask=0x80;
				ps++;
			}else{
				bitmask>>=1;
			}
		}
	}
}



void SPtnEditView::setPtn(const SPtn& ptn)
{
	int w = ptn.m_size.w();
	int h = ptn.m_size.h();
	m_size.setWidth(w);
	m_size.setHeight(h);
	setupBuffer();

	fromSPtn(ptn,w,h,w,h,m_buff);
	QSize size = getContentsSize();
	resizeContents(size.width(),size.height());
}



//ꤷѥm_SPtn˽᤹
const SPtn& SPtnEditView::toSPtn(int w,int h,unsigned char *buff)
{
	delete[]m_SPtn.m_pBuff;
	int xbyte = (w+15)/16*2;
	int bufflen=xbyte*h;
	m_SPtn.m_nBuffsize = bufflen;
	m_SPtn.m_pBuff = (unsigned char*) new char[bufflen];
	m_SPtn.m_size.setW(w);
	m_SPtn.m_size.setH(h);

	int i,j;
	unsigned char* pd;
	unsigned char* ps;
	unsigned char bitmask;

	pd = m_SPtn.m_pBuff;
	for(i=0;i<bufflen;i++) *pd++ = 0;
	
	for(i=0;i<h;i++){
		pd=m_SPtn.m_pBuff + i*xbyte;
		ps=buff + i*w;
		bitmask = 0x80;
		for(j=0;j<w;j++){
			if(*ps)		*pd |= bitmask;
			ps++;
			if(bitmask==1){
				bitmask=0x80;
				pd++;
			}else{
				bitmask>>=1;
			}
		}
	}
	return m_SPtn;
}



//Υѥ m_SPtn˽᤹
const SPtn& SPtnEditView::ptn()
{
	resetSelect(true);
	int w = m_size.width();
	int h = m_size.height();
	return toSPtn(w,h,m_buff);
}




//ContentsκɸѥɸؤѴ
QPoint SPtnEditView::ContentsToPtn(const QPoint& point)
{
	int x = (point.x() - VIEW_MARGIN )/m_viewScale;
	int y = (point.y() - VIEW_MARGIN )/m_viewScale;
	return QPoint(x,y);
}

//ContentsκɸѥɸؤѴ 	
QRect  SPtnEditView::ContentsToPtn(const QRect& rc)
{
	QPoint topleft = ContentsToPtn(rc.topLeft());
	QPoint bottomright = ContentsToPtn(rc.bottomRight());
	return QRect(topleft,bottomright);
}


//ѥκɸContentsɸؤѴ 	
QPoint SPtnEditView::PtnToContents(const QPoint& point)
{
	int x = point.x()*m_viewScale +m_viewScale/2+ VIEW_MARGIN;
	int y = point.y()*m_viewScale +m_viewScale/2+ VIEW_MARGIN;
	return QPoint(x,y);
}	


//ѥκɸContentsɸؤѴ 	
QRect  SPtnEditView::PtnToContents(const QRect& rc)
{
	QPoint topleft = PtnToContents(rc.topLeft());
	QPoint bottomright = PtnToContents(rc.bottomRight());
	return QRect(topleft,bottomright);
}


//ꤷѥɸѥξ˾äƤ뤫
bool SPtnEditView::OnPtn(const QPoint& point)
{
	return (point.x()>=0 
		 && point.x()<m_size.width() 
		 && point.y()>=0 
		 && point.y()<m_size.height()); 
}

//ꤷѥɸѥξ˾äƤ뤫
bool SPtnEditView::OnTemp(const QPoint& point)
{
	return (point.x()>=m_tempOffset.x() 
		 && point.x()<(m_tempOffset.x() + m_tempSize.width()) 
		 && point.y()>=m_tempOffset.y() 
		 && point.y()<(m_tempOffset.y() + m_tempSize.height())); 
}


//åɤ
void SPtnEditView::drawGrid(QPainter*p,const QRect& rcClip)
{
	
	int w = m_size.width() * m_viewScale;
	int h = m_size.height() * m_viewScale;
	int l = VIEW_MARGIN;
	int t = VIEW_MARGIN;
	int r = l+w;
	int b = t+h;
	int i;
	int m;
	QColor col_pin = QColor("blue");
	QColor col = QColor("gray");
	p->setRasterOp(CopyROP);
	QPen pen;
	if(m_viewScale>1){
		pen.setColor(col_pin);
		p->setPen(pen);
		i=0;
		while(i<m_size.width()){
			m=VIEW_MARGIN + i*m_viewScale;
			p->drawLine(m,t,m,b);
			m+=m_viewScale;
			p->drawLine(m,t,m,b);
			i+=10;
		}
		i=0;
		while(i<m_size.height()){
			m=VIEW_MARGIN + i*m_viewScale;
			p->drawLine(l,m,r,m);
			m+=m_viewScale;
			p->drawLine(l,m,r,m);
			i+=10;
		}
		
		pen.setColor(col);
		p->setPen(pen);
				
		m = VIEW_MARGIN;
		for(i=0;i<=m_size.width();i++){
			if((i%10)>1){
				p->drawLine(m,t,m,b);
			}
			m+=m_viewScale;
		}
		m = VIEW_MARGIN;
		for(i=0;i<=m_size.height();i++){
			if((i%10)>1){
				p->drawLine(l,m,r,m);
			}
			m+=m_viewScale;
		}
	}else{
		pen.setColor(col_pin);
		p->setPen(pen);

		i=0;
		while(i<m_size.width()){
			m=VIEW_MARGIN + i;
			p->drawLine(m,t,m,t-5);
			p->drawLine(m,b,m,b+5);
			i+=10;
		}
		i=0;
		while(i<m_size.height()){
			m=VIEW_MARGIN + i;
			p->drawLine(l,m,l-5,m);
			p->drawLine(r,m,r+5,m);
			i+=10;
		}
	}
}


//ǡ 
void SPtnEditView::drawData(QPainter*p,QRect* prcClip)
{
	int l,t,r,b;
	if(prcClip != NULL){
		QRect rcClip = ContentsToPtn(*prcClip);
		l=rcClip.left()-1;
		t=rcClip.top()-1;
		r=rcClip.right()+1;
		b=rcClip.bottom()+1;
		if(l<0)l=0;
		if(t<0)t=0;
		if(r>=m_size.width()) r=m_size.width()-1;
		if(b>=m_size.height()) b=m_size.height()-1;
	}else{
		l=0;
		t=0;
		r=m_size.width()-1;
		b=m_size.height()-1;
	}
	int x,y;
	for(y=t;y<=b;y++){
		for(x=l;x<=r;x++){
			if(pixel(x,y)) drawPixel(p,DRAW_ON,x,y);
		}
	}
}

//ǡ 
void SPtnEditView::drawTempData(QPainter*p,QRect* prcClip,unsigned  nMode)
{
	if(!m_bTempBuffer)return;
	int l,t,r,b;
	if(prcClip != NULL){
		QRect rcClip = ContentsToPtn(*prcClip);
		l=rcClip.left()-1;
		t=rcClip.top()-1;
		r=rcClip.right()+1;
		b=rcClip.bottom()+1;
		if(l<0)l=0;
		if(t<0)t=0;
		if(r>=m_size.width()) r=m_size.width()-1;
		if(b>=m_size.height()) b=m_size.height()-1;
	}else{
		l=0;
		t=0;
		r=m_size.width()-1;
		b=m_size.height()-1;
	}

	int w = m_tempSize.width();
	int h = m_tempSize.height();
	int xoff = m_tempOffset.x();
	int yoff = m_tempOffset.y();

	int y,x;
	
	for(y=0;y<h;y++){
		if(y+yoff >= t && y+yoff <= b){
			for(x=0;x<w;x++){
				if(x+xoff >= l && x+xoff <= r && tempPixel(x,y)) drawPixel(p,nMode,x+xoff,y+yoff);
			}
		}
	}
}




void  SPtnEditView::setPixel(int x,int y,bool bSet)
{
	int w = m_size.width();
	int h = m_size.height();
	if(x>=0 && x<w && y>=0 && y<h){
		m_buff[y*w+x]=(bSet ? 255 : 0);
	}
}

int SPtnEditView::pixel(int x,int y)
{
	int w = m_size.width();
	int h = m_size.height();
	if(x>=0 && x<w && y>=0 && y<h){
		return m_buff[y*w+x];
	}
	return 0;
}

void  SPtnEditView::setTempPixel(int x,int y,bool bSet)
{
	int w = m_tempSize.width();
	int h = m_tempSize.height();
	if(x>=0 && x<w && y>=0 && y<h){
		m_buffTemp[y*w+x]=(bSet ? 255 : 0);
	}
}


int SPtnEditView::tempPixel(int x,int y)
{
	int w = m_tempSize.width();
	int h = m_tempSize.height();
	if(x>=0 && x<w && y>=0 && y<h){
		return m_buffTemp[y*w+x];
	}
	return 0;
}


void  SPtnEditView::drawPixel(QPainter*p,unsigned  nMode,int x,int y)
{
	QColor col;
	RasterOp op;

	switch(nMode){
	case DRAW_ON:
		col = QColor("darkgreen");
		op = Qt::CopyROP;
		break;
	case DRAW_OFF:
		col = QColor("white");
		op = Qt::CopyROP;
		break;
	case DRAW_XOR:
		col = QColor("white");
		op = Qt::XorROP;
		break;
	}
	
	int l=VIEW_MARGIN + x*m_viewScale;
	int t=VIEW_MARGIN + y*m_viewScale;
	p->setRasterOp(op);
	if(m_viewScale>1){
		p->fillRect(l+1,t+1,m_viewScale-1,m_viewScale-1,col);
	}else{
		p->setPen(col);
		p->drawPoint(l,t);
	}
		
}

//ե졼
void SPtnEditView::drawSelectFrame(QPainter* p)
{
	QColor col = QColor("white");
	QPen pen;
	pen.setColor(col);
	p->setPen(pen);
	p->setPen(Qt::DotLine);
	p->setRasterOp(XorROP);
	QRect rc(m_ptButtonDownAtPtn,m_ptLastMoveAtPtn);
	rc = PtnToContents(rc);
	rc=rc.normalize();
	p->drawLine(rc.topLeft(),rc.topRight());
	p->drawLine(rc.topRight(),rc.bottomRight());
	p->drawLine(rc.bottomRight(),rc.bottomLeft());
	p->drawLine(rc.bottomLeft(),rc.topLeft());
}

//ǡΥե졼
void SPtnEditView::drawTempFrame(QPainter*p)
{
	if(!m_bTempBuffer) return;
	QColor col = QColor("white");
	QPen pen;
	pen.setColor(col);
	p->setPen(pen);
	p->setPen(Qt::DotLine);
	p->setRasterOp(XorROP);
	int w = m_tempSize.width();
	int h = m_tempSize.height();
	int xoff = m_tempOffset.x();
	int yoff = m_tempOffset.y();
	QRect rc(xoff,yoff,w,h);
	rc = PtnToContents(rc);
	rc=rc.normalize();
	p->drawLine(rc.topLeft(),rc.topRight());
	p->drawLine(rc.topRight(),rc.bottomRight());
	p->drawLine(rc.bottomRight(),rc.bottomLeft());
	p->drawLine(rc.bottomLeft(),rc.topLeft());
}





//  ǡˡ֤Ǹư֤ޤǤ򥻥åȤ롣
void SPtnEditView::drawTempLine()
{
	clearTemp();
	int x,y,d,k,err;
	int dx = m_ptLastMoveAtPtn.x() - m_ptButtonDownAtPtn.x();
	int dy = m_ptLastMoveAtPtn.y() - m_ptButtonDownAtPtn.y();

	if(dx==0 && dy==0){
		setTempPixel(m_ptButtonDownAtPtn.x(),m_ptButtonDownAtPtn.y(),true);
	}else if(abs(dx) >= abs(dy)){
		if(dx<0) d=-1; else d=1;
		if(dy<0) k=-1; else k=1;
		dx=abs(dx);
		dy=abs(dy);
		err=dx/2;
		x=m_ptButtonDownAtPtn.x();
		y=m_ptButtonDownAtPtn.y();
		for(;;){
			setTempPixel(x,y,true);
			err+=dy;
			if(err>dx){
				y+=k;
				err-=dx;
			}
			if(x==m_ptLastMoveAtPtn.x()) break;
			x+=d;
		}
	}else{
		if(dy<0) d=-1; else d=1;
		if(dx<0) k=-1; else k=1;
		dx=abs(dx);
		dy=abs(dy);
		err=dy/2;
		x=m_ptButtonDownAtPtn.x();
		y=m_ptButtonDownAtPtn.y();
		for(;;){
			setTempPixel(x,y,true);
			err+=dx;
			if(err>dy){
				x+=k;
				err-=dy;
			}
			if(y==m_ptLastMoveAtPtn.y()) break;
			y+=d;
		}

	}

	m_bTempBuffer = true;

}

//ߤ   ǡˡ֤Ǹư֤ޤǤʱߤ򥻥åȤ롣
void SPtnEditView::drawTempCircle()
{
	clearTemp();

	int nXCenter;
	int nYCenter;
	int nXRadius;
	int nYRadius;
	int nLargeRadius;
	int nx,ny,nr;
	int nXOdd,nYOdd;

	QPoint pt[8];

	//Ⱦ¤Υơ֥
	static const int nLimitTable[8]={1,1,2,3,4,4,5,5};
	static const int nXTable[8][5]={
		//Ⱦ 0
		{ 0	},
		//Ⱦ 1
		{ 0	},
		//Ⱦ 2
		{ 2,2 },
		//Ⱦ 3
		{ 3,3,2 },
		//Ⱦ 4
		{ 4,4,4,3 },
		//Ⱦ 5
		{ 5,5,5,4 },
		//Ⱦ 6
		{ 6,6,6,5,4 },
		//Ⱦ 7
		{ 7,7,7,6,5 }
	};

	int nx1,ny1;

	int x,y,r,b;
	if(m_ptLastMoveAtPtn.x()>m_ptButtonDownAtPtn.x()) r=m_ptLastMoveAtPtn.x(); else r=m_ptButtonDownAtPtn.x();
	if(m_ptLastMoveAtPtn.y()>m_ptButtonDownAtPtn.y()) b=m_ptLastMoveAtPtn.y(); else b=m_ptButtonDownAtPtn.y();
	//if(m_ptEnd.y>m_ptStart.y) b=m_ptEnd.y; else b=m_ptStart.y;
	x=m_ptLastMoveAtPtn.x()+m_ptButtonDownAtPtn.x();
	y=m_ptLastMoveAtPtn.y()+m_ptButtonDownAtPtn.y();
	nXCenter=x/2;
	nYCenter=y/2;
	nXOdd=x&1;
	nYOdd=y&1;
	nXRadius=r-nXCenter;
	nYRadius=b-nYCenter;
	if(nXRadius>nYRadius) nLargeRadius=nXRadius; else nLargeRadius=nYRadius;
	nx=nr=nLargeRadius;
	ny=0;

	for(;;){
		if(nXRadius>nYRadius){
			nx1=nx * nYRadius / nXRadius;
			ny1=ny * nYRadius / nXRadius;
			setTempPixel(	nXCenter+nx,			nYCenter+ny1,		true);
			setTempPixel(	nXCenter+nx,			nYCenter-ny1+nYOdd,	true);
			setTempPixel(	nXCenter-nx+nXOdd,		nYCenter+ny1,		true);
			setTempPixel(	nXCenter-nx+nXOdd,		nYCenter-ny1+nYOdd,	true);
			setTempPixel(	nXCenter+ny,			nYCenter+nx1,		true);
			setTempPixel(	nXCenter+ny,			nYCenter-nx1+nYOdd,	true);
			setTempPixel(	nXCenter-ny+nXOdd,		nYCenter+nx1,		true);
			setTempPixel(	nXCenter-ny+nXOdd,		nYCenter-nx1+nYOdd,	true);
		}else{
			if(nYRadius==0){
				nx1=nx;
				ny1=ny;
			}else{
				nx1=nx * nXRadius / nYRadius;
				ny1=ny * nXRadius / nYRadius;
			}
			setTempPixel(	nXCenter+nx1,			nYCenter+ny,		true);
			setTempPixel(	nXCenter+nx1,			nYCenter-ny+nYOdd,	true);
			setTempPixel(	nXCenter-nx1+nXOdd,		nYCenter+ny,		true);
			setTempPixel(	nXCenter-nx1+nXOdd,		nYCenter-ny+nYOdd,	true);
			setTempPixel(	nXCenter+ny1,			nYCenter+nx,		true);
			setTempPixel(	nXCenter+ny1,			nYCenter-nx+nYOdd,	true);
			setTempPixel(	nXCenter-ny1+nXOdd,		nYCenter+nx,		true);
			setTempPixel(	nXCenter-ny1+nXOdd,		nYCenter-nx+nYOdd,	true);
		}


		if(nLargeRadius<8){
			ny++;
			if(ny>=nLimitTable[nLargeRadius])break;
			nx=nXTable[nLargeRadius][ny];
		}else{
			if((nr -=(ny++ << 1) -1)<0)
				nr += (nx-- -1)<<1;
			if(nx<ny) break;
		}
	}
	m_bTempBuffer = true;
}



void SPtnEditView::contentsMousePressEvent(QMouseEvent* me)
{
	//qDebug("contentsMousePressEvent(QMouseEvent* me)");

	//ܥ󲡲ϡ̤Υܥβ٥ȤȯƤ̵뤹롣
	if(m_bLButtonDown || m_bRButtonDown) return;

	
	if(!(me->button() & LeftButton) && !(me->button() & RightButton)) return;
	
	unsigned nMode; 

	QPoint ptAtPtn = ContentsToPtn(QPoint(me->x(),me->y()));
	if(!OnPtn(ptAtPtn)){
		if(m_bTempBuffer){
			resetSelect(true);
			viewport()->update();
		}		
		return;
	}

	if(!OnTemp(ptAtPtn) && m_bTempBuffer){
		resetSelect(true);
		viewport()->update();
	}

	//줿Ͽ
	m_ptButtonDownAtPtn = ptAtPtn;
	m_ptLastMoveAtPtn = ptAtPtn;
	
	if(me->button() & LeftButton){
		if(me->state() & ShiftButton) m_bRButtonDown = true;
		else m_bLButtonDown = true;
	}else{
		m_bRButtonDown = true;
	}
//	if(!m_bRButtonDown && me->button() & LeftButton){
//		m_bLButtonDown = true;
//	}
//	if(!m_bLButtonDown && (me->button() & RightButton)){
//		m_bRButtonDown = true;
//	}

	QPainter *ppainter;
	ppainter = new QPainter(viewport());
	ppainter->translate ( -contentsX(),-contentsY() );
	switch(m_toolmode){
	case TOOL_FREEHAND:
		setPixel(ptAtPtn.x(),ptAtPtn.y(),m_bLButtonDown);
		nMode = (m_bLButtonDown ? DRAW_ON : DRAW_OFF);
		drawPixel(ppainter,nMode,ptAtPtn.x(),ptAtPtn.y());
		break;
	case TOOL_LINE:
		drawTempLine();
		drawTempData(ppainter,NULL,DRAW_XOR);
		break;
	case TOOL_CIRCLE:
		drawTempCircle();
		drawTempData(ppainter,NULL,DRAW_XOR);
		break;
	case TOOL_SELECTOR:
		if(m_bLButtonDown){
			if(m_bTempBuffer){
				m_bDragTemp=true;
			}else{
				drawSelectFrame(ppainter);
			}
		}
		break;
	}

	delete ppainter;

}
void SPtnEditView::contentsMouseReleaseEvent(QMouseEvent *me)
{
	if( ((me->button() & LeftButton )||  (me->button() &RightButton)) && (m_bLButtonDown || m_bRButtonDown)){
//		|| (m_bRButtonDown /*&& (me->button() & RightButton)*/) ){
//	if(   (m_bLButtonDown /*&& (me->button() & LeftButton)*/)
//		|| (m_bRButtonDown /*&& (me->button() & RightButton)*/) ){
		QPainter *ppainter;
		ppainter = new QPainter(viewport());
		ppainter->translate ( -contentsX(),-contentsY() );

		switch(m_toolmode){
		case TOOL_LINE:
		case TOOL_CIRCLE:
			if(m_bLButtonDown){
				drawTempData(ppainter,NULL,DRAW_ON);
				resetSelect(true);
			}else if(m_bRButtonDown){
				drawTempData(ppainter,NULL,DRAW_OFF);
				resetSelect(false);
			}
			break;
		case TOOL_SELECTOR:
			if(m_bLButtonDown){
				if(m_bDragTemp){
					m_bDragTemp=false;
				}else{
					drawSelectFrame(ppainter);
					if(select(QRect(m_ptLastMoveAtPtn,m_ptButtonDownAtPtn))){
						drawTempData(ppainter,NULL,DRAW_OFF);
						drawTempData(ppainter,NULL,DRAW_XOR);
						drawTempFrame(ppainter);
					}
				}
			}
			break;
		}
		delete ppainter;

		if(m_bLButtonDown /*&& (me->button() & LeftButton)*/)  m_bLButtonDown=false;
		if(m_bRButtonDown /*&& (me->button() & RightButton)*/) m_bRButtonDown=false;
	}
}
void SPtnEditView::contentsMouseMoveEvent(QMouseEvent *me)
{
	//ܥ󤬲줿֤ǺȥꥢäƤƤ̵뤹롣
	bool bLButtonDown = m_bLButtonDown /*&& me->state() & LeftButton*/;
	bool bRButtonDown = m_bRButtonDown /*&& me->state() & RightButton*/;

	if(!(bLButtonDown || bRButtonDown)) return;
	QPoint ptAtPtn = ContentsToPtn(QPoint(me->x(),me->y()));

	QPainter *ppainter;
	ppainter = new QPainter(viewport());
	ppainter->translate ( -contentsX(),-contentsY() );
	unsigned nMode; 

	switch(m_toolmode){
	case TOOL_FREEHAND:
		if(OnPtn(ptAtPtn)){
			setPixel(ptAtPtn.x(),ptAtPtn.y(),m_bLButtonDown);
			nMode = (m_bLButtonDown ? DRAW_ON : DRAW_OFF);
			drawPixel(ppainter,nMode,ptAtPtn.x(),ptAtPtn.y());
		}
		break;
	case TOOL_LINE:
		drawTempData(ppainter,NULL,DRAW_XOR);
		m_ptLastMoveAtPtn = ptAtPtn;
		drawTempLine();
		drawTempData(ppainter,NULL,DRAW_XOR);
		break;
	case TOOL_CIRCLE:
		drawTempData(ppainter,NULL,DRAW_XOR);
		m_ptLastMoveAtPtn = ptAtPtn;
		drawTempCircle();
		drawTempData(ppainter,NULL,DRAW_XOR);
		break;
	case TOOL_SELECTOR:
		if(bLButtonDown && 	OnPtn(ptAtPtn)){
			if(m_bDragTemp){
				int offsetx=ptAtPtn.x()-m_ptLastMoveAtPtn.x();
				int offsety=ptAtPtn.y()-m_ptLastMoveAtPtn.y();
				int newoffsetx = m_tempOffset.x()+offsetx;
				int newoffsety = m_tempOffset.y()+offsety;

				if(newoffsetx < 0){
					newoffsetx = 0;
					offsetx = -m_tempOffset.x();
				}else if((newoffsetx+m_tempSize.width()) > m_size.width()){
					newoffsetx= m_size.width() - m_tempSize.width();
					offsetx = newoffsetx-m_tempOffset.x();
				}

				if(newoffsety < 0){
					newoffsety = 0;
					offsety = -m_tempOffset.y();
				}else if((newoffsety+m_tempSize.height()) > m_size.height()){
					newoffsety= m_size.height() - m_tempSize.height();
					offsety = newoffsety-m_tempOffset.y();
				}

				drawTempFrame(ppainter);
				drawTempData(ppainter,NULL,DRAW_XOR);
				m_tempOffset.setX(newoffsetx);
				m_tempOffset.setY(newoffsety);
				drawTempData(ppainter,NULL,DRAW_XOR);
				drawTempFrame(ppainter);
				m_ptLastMoveAtPtn+=QPoint(offsetx,offsety);
			}else{			
				drawSelectFrame(ppainter);
				m_ptLastMoveAtPtn = ptAtPtn;
				drawSelectFrame(ppainter);
			}
		}
		break;
	}
	delete ppainter;
}
//
void SPtnEditView::drawContents(QPainter*p,int clipx,int clipy, int clipw, int cliph )
{
	//qDebug("drawContents");
	p->eraseRect(clipx,clipy,clipw,cliph);
	QRect rcClip(clipx,clipy,clipw,cliph);
	drawGrid(p,rcClip);
	drawData(p,&rcClip);
	drawTempData(p,&rcClip,DRAW_XOR);
	if(m_toolmode==TOOL_SELECTOR){
		drawTempFrame(p);
	}
}
void SPtnEditView::viewportResizeEvent(QResizeEvent * )
{
	//viewport()->update();
}

