// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.

#ifndef PTNEDITVIEW_H
#define PTNEDITVIEW_H

#include <qwidget.h>
#include <qscrollview.h>
#include <qcursor.h>

#include <string>
#include <list>
using namespace std;

class QPainter;
class QCursor;

#include "coord.h"
#include "complib.h"


class SPtnEditView: public QScrollView
{
    Q_OBJECT

public:

enum PTNEDIT_TOOL_MODE{
	TOOL_SELECTOR,
	TOOL_FREEHAND,
	TOOL_LINE,
	TOOL_CIRCLE
	};

enum PTNEDIT_DRAW_MODE{
		DRAW_ON			=1,
		DRAW_OFF		=2,
		DRAW_XOR		=3,
	};

	SPtnEditView(QWidget* parent);	//󥹥ȥ饯
	~SPtnEditView();				//ǥȥ饯

	//void setCopyBuff(SPtnEditCopyBuff* copyBuffer);

	//ɽ˴ؤ
	void RefreshView(){viewport()->update();}

	//।󡦥Ȥ˴Ϣ᥽å
	bool CanZoomIn();
	bool CanZoomOut();
	void ZoomIn();
	void ZoomOut();

	//Խ˴ؤ
	//ԡ
	void copy();
	//å
	void cut();
	//ڡȲǽ
	bool canPaste();
	//ڡ
	void paste();
	//
	void del();
	//UNDO
	void undo();
	//Rotate
	void rotate();
	//Mirror
	void mirror();
	

	//ġ˴Ϣ᥽å
	bool setToolMode(int toolMode);


	void setPtn(const SPtn& ptn);
	const SPtn& ptn();

protected:
	void fromSPtn(const SPtn& ptn,int& dw,int& dh,int maxw,int maxh,unsigned char* buff);//ꤷSPtnХåե
	const SPtn& toSPtn(int w,int h,unsigned char* buff);//ꤷѥm_SPtn˽᤹

protected:
	QSize m_size;
	//int m_width;
	//int m_height;
	unsigned char* m_buff;
	unsigned char* m_buffTemp;


	SPtn m_SPtn;
	int  m_viewScale;				//̾Ψ
	int  m_toolmode;				//ߤġΥ⡼


	bool m_bTempBuffer;				//m_buffTempͭʤȤtrue
	QSize m_tempSize;				//m_buffTempͭϰ
	QPoint m_tempOffset;			//m_buffTemp

	bool m_bLButtonDown;			//ܥβ
	bool m_bRButtonDown;			//ܥβ
	bool m_bDrawSelectFrame;		//Ȥե饰
	bool m_bDrawTempLine;			//ľ߲ե饰
	bool m_bDragTemp;				//ǡΰư

	QPoint m_ptLastMoveAtContents;	//뤬ǸưȤviewportɸ
	QPoint m_ptLastMoveAtPtn;		//뤬ǸưȤpatternɸ
	QPoint m_ptButtonDownAtPtn;		//ܥ󤬲줿Ȥpatternɸ
	QPoint m_ptLastMoveTempAtPtn;	//ǡǸư

protected:
	bool setupBuffer();	//m_width,m_heightΥХåեݤ롣
	QSize getContentsSize();	//ߤγΨȥѥΥ饹ӥ塼ΥƥĤΥ
	void clearTemp();	//ǡ򥼥ꥢ

	//ɸѴ˴ؤ
	QPoint ContentsToPtn(const QPoint& point);	//ContentsκɸѥɸؤѴ
	QRect  ContentsToPtn(const QRect& rc);		//ContentsκɸѥɸؤѴ 	
	QPoint PtnToContents(const QPoint& point);	//ѥκɸContentsɸؤѴ 	
	QRect  PtnToContents(const QRect& rc);		//ѥκɸContentsɸؤѴ 	

	bool OnPtn(const QPoint& point);	//ꤷѥɸѥξ˾äƤ뤫
	bool OnTemp(const QPoint& point);	//ꤷѥɸѥξ˾äƤ뤫

	//̥ե졼˴Ϣ
	void drawGrid(QPainter*p,const QRect& rcClip);

	//ǡ 
	void drawData(QPainter*p,QRect* prcClip);
	void drawTempData(QPainter*p,QRect* prcClip,unsigned  nMode);

	int pixel(int x,int y);
	int tempPixel(int x,int y);
	void setPixel(int x,int y,bool bSet);
	void setTempPixel(int x,int y,bool bSet);
	void drawPixel(QPainter* p,unsigned  nMode,int x,int y);

	//ե졼
	void drawSelectFrame(QPainter*p);

	//ǡΥե졼
	void drawTempFrame(QPainter*p);


	//
	void drawTempLine();

	//ߤ
	void drawTempCircle();
	
	void resetSelect(bool bSet);
	bool select(const QRect& rc);

signals:
	//void cursorMove(int x,int y);
	//void toolChange();

private slots:
	//void whenScroll(int x,int y);
	//void onScrollTimer();
	//void onTimerDrawTemp();
	//void clipboardChanged();

protected:
	void contentsMousePressEvent(QMouseEvent*);
	void contentsMouseReleaseEvent(QMouseEvent *);
	void contentsMouseMoveEvent(QMouseEvent *me);
	void drawContents(QPainter*p,int clipx,int clipy, int clipw, int cliph );	//
	void viewportResizeEvent(QResizeEvent * );
};


#endif